import requests
import json

class CharacterServiceTest:
    def __init__(self,socket="http://114.214.236.207:7878"):
        self.socket = socket
    
    def test_character_create(self):
        url = f"{self.socket}/characters"
        payload = json.dumps({
            "voice_id": 97,
            "avatar_id": "49c838c5ffb211ee9de9a036bc278b4c",
            "background_ids": "185c554affaf11eebd72a036bc278b4c,1b0e2d8bffaf11eebd72a036bc278b4c,20158587ffaf11eebd72a036bc278b4c,2834472affaf11eebd72a036bc278b4c,2c6ddb0affaf11eebd72a036bc278b4c,fd631ec4ffb011ee9b1aa036bc278b4c",
            "name": "测试角色",
            "wakeup_words": "你好啊，海绵宝宝",
            "world_scenario": "海绵宝宝住在深海的大菠萝里面",
            "description": "厨师，做汉堡",
            "emojis": "大笑，微笑",
            "dialogues": "我准备好了"
        })
        headers = {
            'Content-Type': 'application/json'
        }
        response = requests.request("POST", url, headers=headers, data=payload)
        if response.status_code == 200:
            print("角色创建测试成功")
            self.id = response.json()['data']['character_id']
        else:
            raise Exception("角色创建测试失败")

    def test_character_update(self):
        url = f"{self.socket}/characters/"+str(self.id)
        payload = json.dumps({
            "voice_id": 97,
            "avatar_id": "49c838c5ffb211ee9de9a036bc278b4c",
            "background_ids": "185c554affaf11eebd72a036bc278b4c,1b0e2d8bffaf11eebd72a036bc278b4c,20158587ffaf11eebd72a036bc278b4c,2834472affaf11eebd72a036bc278b4c,2c6ddb0affaf11eebd72a036bc278b4c,fd631ec4ffb011ee9b1aa036bc278b4c",
            "name": "测试角色",
            "wakeup_words": "你好啊，海绵宝宝",
            "world_scenario": "海绵宝宝住在深海的大菠萝里面",
            "description": "厨师，做汉堡",
            "emojis": "大笑，微笑",
            "dialogues": "我准备好了"
        })
        headers = {
            'Content-Type': 'application/json'
        }
        response = requests.request("PUT", url, headers=headers, data=payload)
        if response.status_code == 200:
            print("角色更新测试成功")
        else:
            raise Exception("角色更新测试失败")
    
    def test_character_query(self):
        url = f"{self.socket}/characters/{self.id}"
        response = requests.request("GET", url)
        if response.status_code == 200:
            print("角色查询测试成功")
        else:
            raise Exception("角色查询测试失败")
    
    def test_character_delete(self):
        url = f"{self.socket}/characters/{self.id}"
        response = requests.request("DELETE", url)
        if response.status_code == 200:
            print("角色删除测试成功")
        else:
            raise Exception("角色删除测试失败")
        

def character_test():
    character_service_test = CharacterServiceTest()
    character_service_test.test_character_create()
    character_service_test.test_character_update()
    character_service_test.test_character_query()
    character_service_test.test_character_delete()


if __name__ == '__main__':
    character_test()